var dataDomain = ""

function setDataDomain(domain) {
    dataDomain = domain
}
var layer = L.tileLayer('http://mt1.google.cn/vt/lyrs=y@207000000&hl=zh-CN&gl=CN&src=app&x={x}&y={y}&z={z}', {
    minZoom: 1,
    maxZoom: 18,
    zIndex: 1000,
});

var corner1 = L.latLng(89, 3600),
    corner2 = L.latLng(-89, -3600),
    bounds = L.latLngBounds(corner1, corner2);
var map = L.map('map', {
    minZoom: 4,
    maxZoom: 18,
    attributionControl: false,
    maxBounds: bounds,
    center: [39.91583, 116.39085],
    zoom: 6,
    zoomControl: false
});

$.blockUI({
        message: "<div class=\"loading\">\n" +
            "            <div class=\"loading-box\">\n" +
            "                <i class=\"fade-item fade-item1\"></i>\n" +
            "                <i class=\"fade-item fade-item2\"></i>\n" +
            "                <i class=\"fade-item fade-item3\"></i>\n" +
            "                <i class=\"fade-item fade-item4\"></i>\n" +
            "                <i class=\"fade-item fade-item5\"></i>\n" +
            "                <i class=\"fade-item fade-item6\"></i>\n" +
            "                <i class=\"fade-item fade-item7\"></i>\n" +
            "                <i class=\"fade-item fade-item8\"></i>\n" +
            "                <i class=\"fade-item fade-item9\"></i>\n" +
            "                <i class=\"fade-item fade-item10\"></i>\n" +
            "                <i class=\"fade-item fade-item11\"></i>\n" +
            "                <i class=\"fade-item fade-item12\"></i>\n" +
            "            </div>\n" +
            "        </div>",
        css: {
            border: 'none',
            // padding: '15px',
            backgroundColor: 'none',
            left: '40%',
            // border:unset,
            // '-webkit-border-radius': '10px',
            // '-moz-border-radius': '10px',
            // opacity: .5,
            // color: '#fff'
        }
    });

var velocityLayer;

layer.addTo(map);
var bandsWindLayer;
var page = 0;
var uptime; // 当前数据的时间
var layerList = {};
var beforPage = 0;
var step = 30;

// 根据flutter的定位,设置地图的中心位置
function setCenter(lat, lon, zoom) {

    if (lat == undefined || lon == undefined) {
        lat = 39.91583
        lon = 116.39085
    }
    var latlng = L.latLng(lat, lon);
    if (zoom == undefined) {
        zoom = 6;
    }
    map.setView(latlng, 5)
}


// 根据URL计算地图边缘数据
function getMapBounds() {
    var latlng = map.getBounds();
    var zoom = map.getZoom();
    var lat1 = latlng['_southWest'].lat;
    var lat2 = latlng['_northEast'].lat;
    var lon1 = latlng['_southWest'].lng;
    var lon2 = latlng['_northEast'].lng;
    return [lat1, lat2, lon1, lon2, zoom];
}

// 设置地图的缩放级别
function setZoom(zoom) {
    map.setZoom(zoom)
}


function flutterGetData() {
    //    getData();
    return true;
}
//设置时间
function setTime(timeStr) {
    $('#date').html(timeStr)
}
// 设置地图数据
function setMapData(mapData, imgUrl) {
    if (velocityLayer) {
        velocityLayer.setData(mapData);
    } else {
        velocityLayer = L.velocityLayer({
            displayValues: false,
            displayOptions: {
                velocityType: "Global CMEMS",
                displayPosition: "bottomleft",
                displayEmptyString: "No cmems data"
            },
            data: mapData,
            maxVelocity: 1.5,
            // lineWidth:15,
            particleMultiplier: 1 / 100,//粒子的数量

            // colorScale: ["rgb(255,255,255)","rgb(255,255,255)","rgb(255,255,255)","rgb(255,255,255)","rgb(255,255,255)"],

            // colorScale:["orange","red","purple","black"],
            // colorScale:[0xffffff, 0x7453ff, 0x1e8dff, 0x12b6ff, 0x06dfff, 0x03f2b6, 0x00eb0b, 0xb0ff33, 0xffec15, 0xffc513, 0xff672b, 0xff2ae3, 0xaf00e9],
            velocityScale: 0.2 // arbitrary default 0.005

        });
        // layerControl.addOverlay(velocityLayer, "Wind - Global");
        map.addLayer(velocityLayer)
        velocityLayer.setData(mapData);
    }
    $.unblockUI();
}

map.on('movestart', function () {
    // if(velocityLayer){
    //     map.removeLayer(velocityLayer);
    // }
})
function formatDegree(value) {
    ///<summary>将度转换成为度分秒</summary>
    value = Math.abs(value);
    var v1 = Math.floor(value);//度
    var v2 = Math.floor((value - v1) * 60);//分
    var v3 = Math.round((value - v1) * 3600 % 60);//秒
    return v1 + '° ' + ("00" + v2).slice(-2) + '\' ' + ("00" + v3).slice(-2) + '" ';
}
var marker;
var markerLatlng;

function getCmems(lat, lng) {
    var geohash = encodeGeoHash(lat, lng);

}
function getUV(latlng) {
    if (velocityLayer != null) {
        var pos = velocityLayer._map.containerPointToLatLng(map.latLngToContainerPoint(latlng));
        var gridValue = velocityLayer._windy.interpolatePoint(pos.lng, pos.lat);
        if (gridValue && !isNaN(gridValue[0]) && !isNaN(gridValue[1]) && gridValue[2]) {
            u = gridValue[0]
            v = gridValue[1]
            var speed = Math.round(Math.sqrt(u * u + v * v) * 10000) / 10000;
            var dir = -Math.atan2(-u, v) * 180.0 / Math.PI + 180;
            if (dir < 0) dir += 360.0;
            else if (dir >= 360) dir -= 360.0;
            dir = Math.round(dir);
            $('#dir').html(dir + "°")
            $('#speed').html(speed.toFixed(2) + " m/s")
        } else {
            $('#dir').html(" - ")
            $('#speed').html(" - ")
        }
    }
}
function moveEvent(latlng) {
    //    if (marker) marker.remove();
    //
    //    marker = L.marker(latlng, { draggable: true });
    // var geohash=encodeGeoHash(latlng.lat,latlng.lng);
    // $.getJSON('/weather/v1/getDepth',{geohash:geohash},function(ret){
    //     if(ret.code==0){
    //         $('#depth').html(ret.data.depth)
    //     }else{
    //         $('#depth').html('error')
    //     }
    // })
    var lng = latlng.lng
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    $('#lat').html((latlng.lat > 0 ? 'N ' : 'S ') + "<span style='color:orange'>" + formatDegree(latlng.lat)) + "</span>"
    $('#lon').html((lng > 0 ? 'E ' : 'W ') + "<span style='color:orange'>" + formatDegree(lng)) + "</span>"
    getUV(latlng);

}
function getDepth(lat, lng) {
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    if ($('#dir').text().trim().length > 1) {
        if (dataDomain.length > 0) {
            var geohash = encodeGeoHash(lat, lng);
            //https://dosl.yuchong.ink:7043/weather/v1/getDepth'
            $.getJSON(dataDomain + '/weather/v1/getDepth', { geohash: geohash }, function (ret) {
                if (ret.code == 0) {
                    $('#depth').html(ret.data.depth + ' m')
                } else {
                    $('#depth').html('error')
                }
            })
        }

    } else {
        $('#depth').html(' - ')
    }
}

map.on('contextmenu', function (e) {
    // contextmenu 事件与flutter的点击事件冲突

})
map.on('click', function (e) {
    //    makeMarker(e.latlng)
})
map.on('zoomend', function (e) {

})
map.on('move', function (e) {
    moveEvent(map.getCenter());
})
map.on('moveend', function (e) {
    $.unblockUI();
    $.blockUI({
        message: "<div class=\"loading\">\n" +
            "            <div class=\"loading-box\">\n" +
            "                <i class=\"fade-item fade-item1\"></i>\n" +
            "                <i class=\"fade-item fade-item2\"></i>\n" +
            "                <i class=\"fade-item fade-item3\"></i>\n" +
            "                <i class=\"fade-item fade-item4\"></i>\n" +
            "                <i class=\"fade-item fade-item5\"></i>\n" +
            "                <i class=\"fade-item fade-item6\"></i>\n" +
            "                <i class=\"fade-item fade-item7\"></i>\n" +
            "                <i class=\"fade-item fade-item8\"></i>\n" +
            "                <i class=\"fade-item fade-item9\"></i>\n" +
            "                <i class=\"fade-item fade-item10\"></i>\n" +
            "                <i class=\"fade-item fade-item11\"></i>\n" +
            "                <i class=\"fade-item fade-item12\"></i>\n" +
            "            </div>\n" +
            "        </div>",
        css: {
            border: 'none',
            // padding: '15px',
            backgroundColor: 'none',
            left: '40%',
            // border:unset,
            // '-webkit-border-radius': '10px',
            // '-moz-border-radius': '10px',
            // opacity: .5,
            // color: '#fff'
        }
    });
    if (velocityLayer) {
        velocityLayer._clearAndRestart();
    }

    getDepth(map.getCenter().lat, map.getCenter().lng);
    setTimeout(function(){
        window.nativeWebView.callHandler("loadData", map.getCenter().lat, map.getCenter().lng);
     }, 300);

    //    $('.leaflet-map-pane canvas').css('z-index', 1000)
    //    getData();

})

$('#go2Detail').bind('click', function () {
    window.nativeWebView.callHandler("go2Detail", map.getCenter().lat, map.getCenter().lng);
})