
var dataDomain = ""

function setDataDomain(domain) {
    dataDomain = domain
}

var layer = L.tileLayer('http://mt1.google.cn/vt/lyrs=y@207000000&hl=zh-CN&gl=CN&src=app&x={x}&y={y}&z={z}', {
    minZoom: 1,
    maxZoom: 18,
    zIndex: 1000,
});

var corner1 = L.latLng(89, 180 + 360),
    corner2 = L.latLng(-89, -180 - 360),
    bounds = L.latLngBounds(corner1, corner2);
var map = L.map('map', {
    // crs: L.CRS.Baidu,
    minZoom: 4,
    maxZoom: 18,
    attributionControl: false,
    maxBounds: bounds,
    center: [39.91583, 116.39085],
    zoom: 6,
    zoomControl: false
    // layer:[layer]
});
$.blockUI({
        message: "<div class=\"loading\">\n" +
            "            <div class=\"loading-box\">\n" +
            "                <i class=\"fade-item fade-item1\"></i>\n" +
            "                <i class=\"fade-item fade-item2\"></i>\n" +
            "                <i class=\"fade-item fade-item3\"></i>\n" +
            "                <i class=\"fade-item fade-item4\"></i>\n" +
            "                <i class=\"fade-item fade-item5\"></i>\n" +
            "                <i class=\"fade-item fade-item6\"></i>\n" +
            "                <i class=\"fade-item fade-item7\"></i>\n" +
            "                <i class=\"fade-item fade-item8\"></i>\n" +
            "                <i class=\"fade-item fade-item9\"></i>\n" +
            "                <i class=\"fade-item fade-item10\"></i>\n" +
            "                <i class=\"fade-item fade-item11\"></i>\n" +
            "                <i class=\"fade-item fade-item12\"></i>\n" +
            "            </div>\n" +
            "        </div>",
        css: {
            border: 'none',
            // padding: '15px',
            backgroundColor: 'none',
            left: '40%',
            // border:unset,
            // '-webkit-border-radius': '10px',
            // '-moz-border-radius': '10px',
            // opacity: .5,
            // color: '#fff'
        }
    });

var velocityLayer;

function getWaveLevel(h) {
    var level = 0;
    if (h >= 14) {
        level = 9 + (h - 14) / 10
    } else if (h >= 9) {
        level = 8 + ((h - 9) / (14 - 9))
    } else if (h >= 6) {
        level = 7 + ((h - 6) / (9 - 6))
    } else if (h >= 4) {
        level = 6 + ((h - 4) / (6 - 4))
    } else if (h >= 2.5) {
        level = 5 + ((h - 2.5) / (4 - 2.5))
    } else if (h >= 1.25) {
        level = 4 + ((h - 1.25) / (2.5 - 1.25))
    } else if (h >= 0.5) {
        level = 3 + ((h - 0.5) / (1.25 - 0.5))
    } else if (h >= 0.1) {
        level = 2 + ((h - 0.1) / (0.5 - 0.1))
    } else if (h > 0) {
        level = 1 + h / 0.1
    }
    return level;
}
function fromWaveLevel(h) {
    var speed;
    if (h >= 9) {
        speed = (h - 9) * 10 + 14;
    } else if (h >= 8) {
        speed = (h - 8) * (14 - 9) + 9;
    } else if (h >= 7) {
        speed = (h - 7) * (9 - 6) + 6;
    } else if (h >= 6) {
        speed = (h - 6) * (6 - 4) + 4;
    } else if (h >= 5) {
        speed = (h - 5) * (4 - 2.5) + 2.5;
    } else if (h >= 4) {
        speed = (h - 4) * (2.5 - 1.25) + 1.25;
    } else if (h >= 3) {
        speed = (h - 3) * (1.25 - 0.5) + 0.5;
    } else if (h >= 2) {
        speed = (h - 2) * (0.5 - 0.1) + 0.1;
    } else {
        speed = (h - 1) * 0.1
    }
    if (speed < 0) speed = 0
    return speed
}

var page = 3;
clicked = true;
var uptime;
var layerList = {};
var beforPage = 3;
var step = 30;
var imgLayer1, imgLayer2, imgLayer3;

// 根据flutter的定位,设置地图的中心位置
function setCenter(lat, lon, zoom) {

    if (lat == undefined || lon == undefined) {
        lat = 39.91583
        lon = 116.39085
    }
    var latlng = L.latLng(lat, lon);
    if (zoom == undefined) {
        zoom = 6;
    }
    map.setView(latlng, 5)
}


// 根据URL计算地图边缘数据
function getMapBounds() {
    var latlng = map.getBounds();
    var zoom = map.getZoom();
    var lat1 = latlng['_southWest'].lat;
    var lat2 = latlng['_northEast'].lat;
    var lon1 = latlng['_southWest'].lng;
    var lon2 = latlng['_northEast'].lng;
    return [lat1, lat2, lon1, lon2, zoom];
}
//设置时间
function setTime(timeStr) {
    $('#date').html(timeStr)
}
// 设置地图数据
function setMapData(mapData, imgUrl) {

    if (imgUrl) {
        if (imgLayer1) {
            map.removeLayer(imgLayer1);
            map.removeLayer(imgLayer2);
            map.removeLayer(imgLayer3);
        }
        var imageUrl = imgUrl,
            imageBounds = [[-80, -180], [80, 179.91666666666663]];
        imgLayer1 = L.imageOverlay(imageUrl, imageBounds, { opacity: 0.7 });
        imageBounds = [[-80, -180 + 360], [80, 179.91666666666663 + 360]];
        imgLayer2 = L.imageOverlay(imageUrl, imageBounds, { opacity: 0.7 });
        imageBounds = [[-80, -180 - 360], [80, 179.91666666666663 - 360]];
        imgLayer3 = L.imageOverlay(imageUrl, imageBounds, { opacity: 0.7 });
        imgLayer1.addTo(map);
        imgLayer2.addTo(map);
        imgLayer3.addTo(map);
    }


    if (velocityLayer) {
        velocityLayer.setData(mapData);
    } else {
        velocityLayer = L.velocityLayer({
            displayValues: true,
            displayOptions: {
                velocityType: "Global Wind",
                displayPosition: "bottomleft",
                displayEmptyString: "No wind data"
            },
            data: mapData,
            maxVelocity: 10,
            lineWidth: 10,
            frameRate: 40,
            particleMultiplier: 1 / 1500,//粒子的数量
            colorScale: [
                "rgb(23,190,207)",

                "rgb(51,160,44)",
                // "rgb(255,255,203)",
                "rgb(255,255,156)",
                "rgb(255,224,0)",
                "rgb(255,177,0)",
                "rgb(255,130,0)",
                "rgb(255,83,0)",
                "rgb(198,0,0)",
                "rgb(104,0,0)",
                "rgb(10,0,0)"
            ],
            velocityScale: 0.005 // arbitrary default 0.005
        });

        map.addLayer(velocityLayer)
        velocityLayer.setData(mapData);
    }
    $.unblockUI();
}

map.on('move', function (e) {
    moveEvent(map.getCenter());
})
map.on('moveend', function (e) {
    $.unblockUI();
    $.blockUI({
        message: "<div class=\"loading\">\n" +
            "            <div class=\"loading-box\">\n" +
            "                <i class=\"fade-item fade-item1\"></i>\n" +
            "                <i class=\"fade-item fade-item2\"></i>\n" +
            "                <i class=\"fade-item fade-item3\"></i>\n" +
            "                <i class=\"fade-item fade-item4\"></i>\n" +
            "                <i class=\"fade-item fade-item5\"></i>\n" +
            "                <i class=\"fade-item fade-item6\"></i>\n" +
            "                <i class=\"fade-item fade-item7\"></i>\n" +
            "                <i class=\"fade-item fade-item8\"></i>\n" +
            "                <i class=\"fade-item fade-item9\"></i>\n" +
            "                <i class=\"fade-item fade-item10\"></i>\n" +
            "                <i class=\"fade-item fade-item11\"></i>\n" +
            "                <i class=\"fade-item fade-item12\"></i>\n" +
            "            </div>\n" +
            "        </div>",
        css: {
            border: 'none',
            // padding: '15px',
            backgroundColor: 'none',
            left: '40%',
            // border:unset,
            // '-webkit-border-radius': '10px',
            // '-moz-border-radius': '10px',
            // opacity: .5,
            // color: '#fff'
        }
    });
    if (velocityLayer) {
        velocityLayer._clearAndRestart();
    }
    getDepth(map.getCenter().lat, map.getCenter().lng);
    setTimeout(function(){
        window.nativeWebView.callHandler("loadData", map.getCenter().lat, map.getCenter().lng);
    }, 300);
})
map.on('zoomend', function (e) {
    // getData();
})
layer.addTo(map);
function formatDegree(value) {
    ///<summary>将度转换成为度分秒</summary>
    value = Math.abs(value);
    var v1 = Math.floor(value);//度
    var v2 = Math.floor((value - v1) * 60);//分
    var v3 = Math.round((value - v1) * 3600 % 60);//秒
    return v1 + '° ' + ("00" + v2).slice(-2) + '\' ' + ("00" + v3).slice(-2) + '" ';
}
var marker;
var markerLatlng;

$('.close').click(function () {
    $('.message').removeClass('active');
    $('#lat').html('')
    $('#lon').html('')
    if (marker) marker.remove();
})

function getUV(latlng) {
    if (velocityLayer != null) {
        var pos = velocityLayer._map.containerPointToLatLng(map.latLngToContainerPoint(latlng));
        var gridValue = velocityLayer._windy.interpolatePoint(pos.lng, pos.lat);
        if (gridValue && !isNaN(gridValue[0]) && !isNaN(gridValue[1]) && gridValue[2]) {
            u = gridValue[0]
            v = gridValue[1]
            var speed = Math.round(Math.sqrt(u * u + v * v) * 10000) / 10000;
            var dir = -Math.atan2(-u, v) * 180.0 / Math.PI + 180;
            if (dir < 0) dir += 360.0;
            else if (dir >= 360) dir -= 360.0;
            dir = Math.round(dir);
            speed = fromWaveLevel(speed)
            $('#dir').html(dir + "°")
            $('#speed').html(speed.toFixed(2) + " m")
        } else {
            $('#dir').html(" - ")
            $('#speed').html(" - ")
        }
    }
}

function moveEvent(latlng) {
    var lng = latlng.lng
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    $('#lat').html((latlng.lat > 0 ? 'N ' : 'S ') + "<span style='color:orange'>" + formatDegree(latlng.lat)) + "</span>"
    $('#lon').html((lng > 0 ? 'E ' : 'W ') + "<span style='color:orange'>" + formatDegree(lng)) + "</span>"
    getUV(latlng);
    $('.message').addClass('active')
}

function getDepth(lat, lng) {
    while (lng > 180) {
        lng = lng - 360
    }
    while (lng < -180) {
        lng = lng + 360
    }
    if ($('#dir').text().trim().length > 1) {
        if (dataDomain.length > 0) {
            var geohash = encodeGeoHash(lat, lng);
            //'https://dosl.yuchong.ink:7043/weather/v1/getDepth'
            $.getJSON(dataDomain + '/weather/v1/getDepth', { geohash: geohash }, function (ret) {
                if (ret.code == 0) {
                    $('#depth').html(ret.data.depth + ' m')
                } else {
                    $('#depth').html('error')
                }
            })
        }

    } else {
        $('#depth').html(' - ')
    }
}

map.on('contextmenu', function (e) {
    //    makeMarker(e.latlng)

})
map.on('click', function (e) {
    //    makeMarker(e.latlng)
})
$('#go2Detail').bind('click', function () {
    window.nativeWebView.callHandler("go2Detail", map.getCenter().lat, map.getCenter().lng);
})